namespace eval ::apache1.3:: {}

proc ::apache1.3::parseAccess {elements parser dirDef xmlConf currentContainer} {
    set xuiObj [apacheparserutils::getOrCreateIfNotExists access \
            $dirDef $xmlConf $currentContainer]
    set name [string tolower [lindex $elements 0]]
    if [regexp env [lindex $elements 2] ] {
	set environment 1
	set variable [lindex [split [lindex $elements 2] =] 1]
	set newElement [ $xuiObj newChild ]
	$xuiObj insertChild $newElement
	$subject selectComponentByName env
	[$subject getComponentByName env] setValue $variable
    } else {
	foreach host [lrange $elements 2 end ] {
	    set newElement [ $xuiObj newChild ]
	    $xuiObj insertChild $newElement
	    [$newElement getComponentByName action] selectItem $name
	    set subject [$newElement getComponentByName subject]
	    $subject selectComponentByName host
	    set hostAlternate [$subject getComponentByName host]
	    switch $host {
		all {
		    $hostAlternate selectComponentByName all
		} default {
		    $hostAlternate selectComponentByName ipDom
		    [$hostAlternate getComponentByName ipDom] setValue $host
		}
	    }
	}
    }
}

proc ::apache1.3::dumpAccess { xuiObj } {
    set result {}
    foreach child [ $xuiObj getChildren ] {
	append result "[[$child getComponentByName action] getSelected] from "
	set subject [$child getComponentByName subject]
	switch  [$subject getSelectedComponentName] {
	    env {
		append result \
			"env=[[$subject getSelectedComponent] getValue]\n"
	    } host {
		switch [[$subject getSelectedComponent] \
			getSelectedComponentName] {
		    all {
			append result "all\n"
		    } default {
			append result "[[[$subject getSelectedComponent] \
				getSelectedComponent] getValue]\n"
		    }
		}
	    } default {
		error " [$subject getSelectedComponentName] "
	    }
	    
	}
    }
    return $result
}

